---------------------------------------------------------------------------------------------------
--
-- Title       : m_refri_abs
-- Design      : m_refri_abs
-- Author      : Calazans
-- Company     : PUCRS
--
---------------------------------------------------------------------------------------------------
--
-- File        : m_refri_abs.vhd
-- Generated   : Thu Apr 27 00:32:29 2006
-- From        : interface description file
-- By          : Itf2Vhdl ver. 1.20
--
---------------------------------------------------------------------------------------------------
--
-- Description : 
--
---------------------------------------------------------------------------------------------------

--{{ Section below this comment is automatically maintained
--   and may be overwritten
--{entity {m_refri_abs} architecture {m_refri_abs}}

library IEEE;
use IEEE.STD_LOGIC_1164.all; 
package refri is
	type cmd is (Nada, M025, M050, M100, DEV, MEET, ETIRPS);
end package;


library IEEE;
use IEEE.STD_LOGIC_1164.all;
use work.refri.all;

entity m_refri_abs is
	 port(
		 clock : in STD_LOGIC;
		 reset : in STD_LOGIC;
		 comando : in cmd;
		 D025 : out STD_LOGIC;
		 D050 : out STD_LOGIC;
		 D100 : out STD_LOGIC;
		 LMEET : out STD_LOGIC;
		 LETIRPS : out STD_LOGIC
	     );
end m_refri_abs;

--}} End of automatically maintained section

architecture m_refri_abs of m_refri_abs is	
type states is (S000,S025,S050,S075,S100,S125,S150);
signal EA, PE: states;	
signal D025_int, D050_int, D100_int, LMEET_int, LETIRPS_int : std_logic;
begin	  	
	
	process (clock, reset)
	begin 
		if reset='1' then EA <= S000;
		elsif clock'event and clock='1' then
			EA <= PE;
		end if;
	end process;
	
	process (EA,comando)
	begin 	
		-- Valor de atribuicao por omissao
		D025_int <='0'; D050_int <='0'; D100_int <='0'; LMEET_int <='0'; LETIRPS_int <='0'; 
		case comando is	  
			when NADA    => 
				PE <= EA;
			when M025    =>
				if EA /= S150 then
					PE <= states'Succ(EA);
				else PE<=EA; D025_int<='1';
				end if;
			when M050    =>
				case EA is
					when S000 =>
						PE <= S050;
					when S025 =>
						PE <= S075;
					when S050 =>
						PE <= S100;
					when S075 =>
						PE <= S125;
					when others =>
						PE <= S150;
						if EA=S125 then D025_int<='1'; end if;
						if EA=S150 then D050_int<='1'; end if;
				end case;
			when M100    =>
				case EA is
					when S000 =>
						PE <= S100;
					when S025 =>
						PE <= S125;
					when others =>
						PE <= S150;
						if EA=S075 or EA=S125 then D025_int<='1'; end if;
						if EA=S100 or EA=S125 then D050_int<='1'; end if;
						if EA=S150 then D100_int<='1'; end if;
				end case;
			when DEV     =>	 
				PE <= S000;
				if EA >= S100 then D100_int <= '1'; end if;
				if EA=S050 or EA=S075 or EA=S150 then D050_int<='1'; end if;
				if EA=S025 or EA=S075 or EA=S125 then D025_int<='1'; end if;
			when MEET    =>
				if EA=S150	then
					PE <= S000;
					LMEET_int <= '1';
				else
					PE <= EA; 
				end if;
			when ETIRPS  =>
				if EA=S150	then
					PE <= S000;
					LETIRPS_int <= '1';
				else
					PE <= EA;
				end if;
			when others =>
				null;
		end case;
	end process;		  
	
	-- Atencao: Processo importante que limita saidas a durarem exatamente
	-- 1 ciclo de relogio - Sincroniza aprecimento de saidas.
	process (clock, reset)
	begin 
		if reset='1' 
			then D025 <= '0'; D050 <= '0'; D100 <= '0';	LMEET <= '0'; LETIRPS <= '0';
		elsif clock'event and clock='1' then
			D025 <= D025_int; D050 <= D050_int;
			D100 <= D100_int; LMEET <= LMEET_int; LETIRPS <= LETIRPS_int;
		end if;					  			   
	end process;

end m_refri_abs;
